//
// Created by Daniil Golov on 04.11.2024.
//
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;
using pii = pair<int, int>;

int main() {
    int n;
    cin >> n;

    vector<pii> a (n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].second;
        if (a[i].second < a[i].first) {
            a[i] = {a[i].second, a[i].first};
        }
    }
    sort(a.begin(), a.end(), [&](pii x, pii y){
        return x.first < y.first;
    });

    for (int i = 0; i < n - 1; i++) {
        if (a[i].second > a[i + 1].second) {
            cout << "-1\n";
            return 0;
        }
    }
    for (int i = 0; i < n; i++) {
        cout << a[i].first << ' ';
    }
    cout << '\n';
    for (int i = 0; i < n; i++) {
        cout << a[i].second << ' ';
    }
    return 0;
}