#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solveTest() {
  int n, m, k; cin >> n >> m >> k;
  vector<int> p(n);
  for (int& x : p) {
    cin >> x;
    --x;
  }
  vector<int> a(m);
  for (int& x : a) {
    cin >> x;
    --x;
  }
  vector<pair<int, int>> segments(k);
  for (auto& [l, r] : segments) {
    cin >> l >> r;
    --l;
  }
  vector go(k, vector<int>(n + 1, -1));
  for (int i = 0; i < k; ++i) {
    auto[l, r] = segments[i];
    go[i][n] = n;
    for (int j = 0; j < n; ++j) {
      int curj = j;
      for (int t = l; t < r; ++t) {
        int x = a[t];
        if (x != p[curj]) {
          curj = 0;
        }
        if (x == p[curj]) {
          curj++;
          if (curj == n) {
            break;
          }
        }
      }
      go[i][j] = curj;
    }
  }
  int const INF = int(1e9);
  vector dp(1 << k, vector<int>(n + 1, INF));
  vector par(1 << k, vector<pair<int, int>>(n + 1));
  dp[0][0] = 0;
  for (int mask = 0; mask < (1 << k); ++mask) {
    for (int cur = 0; cur < n; ++cur) {
      for (int add = 0; add < k; ++add) {
        if (mask >> add & 1) {
          continue;
        }
        int nw = go[add][cur];
        if (dp[mask | (1 << add)][nw] > dp[mask][cur] + 1) {
          dp[mask | (1 << add)][nw] = dp[mask][cur] + 1;
          par[mask | (1 << add)][nw] = {mask, cur};
        }
      }
    }
  }
  int bestMask = -1;
  int bestScore = INF;
  for (int i = 0; i < (1 << k); ++i) {
    if (dp[i][n] < bestScore) {
      bestScore = dp[i][n];
      bestMask = i;
    }
  }

  if (bestMask < 0) {
    cout << -1 << "\n";
    return;
  }
  vector<int> path;
  int curi = bestMask;
  int curj = n;
  while (curi > 0) {
    auto[pi, pj] = par[curi][curj];
    path.push_back(__lg(curi ^ pi));
    curi = pi;
    curj = pj;
  }
  reverse(path.begin(), path.end());
  cout << path.size() << "\n";
  for (int x : path) cout << x + 1 << " ";
  cout << "\n";
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int t; cin >> t;
  while (t--) solveTest();
  return 0;
}
