from itertools import repeat


def small(n):
    if n == 1:
        return [[1]]
    elif n < 5:
        return [[-1]]
    return [[1, 1, 3, 3, 3],
            [2, 1, 1, 5, 3],
            [2, 2, 1, 5, 3],
            [2, 4, 4, 5, 5],
            [2, 4, 4, 4, 5]]


def big(n):
    a = [[q] * n for q in range(n)]
    mid_l, mid_r = (n - 1) // 2, n // 2
    left, right, mid = mid_l - 1, mid_r, mid_l + 1
    for q in range(1, mid):
        a[q][left:right] = repeat(q - 1, right - left)
        left, right = left - 1, right + 1
    for q in range(mid + 1, n):
        a[q][:q - mid] = repeat(q - 1, q - mid)
    for q in range(mid):
        a[q][-2] = a[q][-1] = mid - 1
    a[0][-2] *= (n % 2 == 0)
    for q in range(mid, n):
        a[q][-1] = n - 1
    return [[q1+1 for q1 in q] for q in a]


N = int(input())
ans = small(N) if N <= 5 else big(N)
print(*(' '.join(map(str, q)) for q in ans), sep='\n')
