#include <bits/stdc++.h>
 
using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
 
long long distance(long long x1, long long y1, long long x2, long long y2) {
    return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
}

const int MAX_COORD = 1e9;
 
int main() {
    long long x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    long long d12 = distance(x1, y1, x2, y2);
    long long d13 = distance(x1, y1, x3, y3);
    long long d23 = distance(x2, y2, x3, y3);
    long long maxDist = max({d12, d13, d23});
    long long ansx1 = 0, ansy1 = 0, ansx2 = 0, ansy2 = 0;
    if (maxDist == d12) {
        ansx1 = x1;
        ansy1 = y1;
        ansx2 = x2;
        ansy2 = y2;
    } else if (maxDist == d13) {
        ansx1 = x1;
        ansy1 = y1;
        ansx2 = x3;
        ansy2 = y3;
    } else {
        ansx1 = x2;
        ansy1 = y2;
        ansx2 = x3;
        ansy2 = y3;
    }
    long long g = gcd(ansx1 - ansx2, ansy1 - ansy2);
    long long dx = (ansx2 - ansx1) / g;
    long long dy = (ansy2 - ansy1) / g;
    
    
    int MOD = 1e8;
    long long cf1 = rng() % MOD;
    while (ansx1 + cf1 * dx < -MAX_COORD || ansx1 + cf1 * dx > MAX_COORD || ansy1 + cf1 * dy < -MAX_COORD || ansy1 + cf1 * dy > MAX_COORD) {
        cf1 = rng() % MOD;
    }

    long long cf2 = rng() % MOD;
    while (ansx1 + cf2 * dx < -MAX_COORD || ansx1 + cf2 * dx > MAX_COORD || ansy1 + cf2 * dy < -MAX_COORD || ansy1 + cf2 * dy > MAX_COORD
        || ansx1 + cf1 * dx == ansx1 + cf2 * dx && ansy1 + cf1 * dy == ansy1 + cf2 * dy) {
        cf2 = rng() % MOD;
    }

    cout << ansx1 + cf1 * dx << " " << ansy1 + cf1 * dy << " ";
    cout << ansx1 + cf2 * dx << " " << ansy1 + cf2 * dy << endl;
    return 0;
}
