#include <iostream>
#include <vector>
#include <algorithm>



bool comp(const std::pair<int, int>& l, const std::pair<int, int>& r) {
	return (l.first + l.second) < (r.first + r.second);
}

int main() {
	int n, x;
	std::cin >> n;
	std::vector<std::pair<int, int>>V(n);
	for (int i = 0; i < n; i++) {
		std::cin >> x;
		std::pair<int, int>p = std::pair<int, int>(x, 0);
		V[i] = p;
	}
	for (int i = 0; i < n; i++) {
		std::cin >> x;
		V[i].second = x;
	}
	std::sort(V.begin(), V.end(), comp);
	std::vector<int>array1, array2;
	for (int i = 0; i < n; i++) {
		array1.push_back(std::min(V[i].first, V[i].second));
		array2.push_back(std::max(V[i].first, V[i].second));
	}
	bool flag1 = true, flag2 = true;
	for (int i = 0; i < n - 1; i++) {
		if (array1[i + 1] < array1[i]) {
			flag1 = false;
			break;
		}
	}
	for (int i = 0; i < n - 1; i++) {
		if (array2[i + 1] < array2[i]) {
			flag2 = false;
			break;
		}
	}
	if ((flag1 == false) || (flag2 == false)) {
		std::cout << -1;
	}
	else {
		for (int i = 0; i < n; i++) {
			std::cout << array1[i] << ' ';
		}
		std::cout << '\n';
		for (int i = 0; i < n; i++) {
			std::cout << array2[i] << ' ';
		}
	}
}