/* 10-1-11-12-E */

// #if 0
#include <iostream>

typedef signed long long SLL;

struct vec2
{
  double X, Y;

    vec2( )
  {
  }


  vec2( double X, double Y ): X(X), Y(Y)
  {
  }

  double length( void )
  {
    return sqrt(X * X + Y * Y);
  }

  vec2 operator+( vec2 k )
  {
    return {X + k.X, Y + k.Y};
  }

  vec2 operator-( vec2 k )
  {
    return {X - k.X, Y - k.Y};
  }

  vec2 operator*( double k )
  {
    return {X * k, Y * k};
  }
};

int main( void )
{
  SLL k;
  vec2 Begin, End;
  int n; 
  static int a[100000];
  std::cin >> Begin.X >> Begin.Y >> End.X >> End.Y >> n;

  for (int i = 0; i < n; i++)
    std::cin >> a[i];

  int sum = 0;
  for (int i = 0; i < n; i++)
    sum += a[i];
  int length = (Begin - End).length();
  if (length > sum)
  {
    std::cout << "Impossible";
    return 0;
  }
  if (n == 1)
  {
    if (length != sum)
      std::cout << "Impossible";
    else
    {
      std::cout << "Possible\n";
      std::cout << End.X << " " << End.Y;
    }
    return 0;
  }
  SLL SumA = 0, SumB = sum;
  SLL SumAN = -1;

  for (int i = 0; i < n; i++)
  {
    SumA += a[i];
    SumB -= a[i];

    if (SumA + SumB >= length && SumA + length >= SumB && SumB + length >= SumA)
    {
      SumAN = i + 1;
      break;
    }
  }
  if (SumAN == -1)
  {
    std::cout << "Impossible\n";
    return 0;
  }
  long double cosA;
  if (length != 0)
    cosA = (SumA * SumA + length * length - SumB * SumB) / ((long double)2.0 * SumA * length);
  else
    cosA = 1;
  
  // // 100%
  // long double cosG = (End.X - Begin.X) / length;
  // long double sinA = sqrt(1 - cosA * cosA);
  // long double sinG = sqrt(1 - cosG * cosG);
  // 
  // long double cosS = cosA * cosG - sinA * sinG;
  // long double S = acos(cosS);

  long double f;
  if (length != 0)
    f = acos((End.X - Begin.X) / length);
  else
    f = 0;
  if (End.Y - Begin.Y != 0)
    f = (End.Y - Begin.Y) / abs(End.Y - Begin.Y) * abs(f);
  else
    f = 0;
  long double alpha = acos(cosA);
  long double b1 = f - alpha;

  std::cout << "Possible\n";
  vec2 e = Begin;
  for (int i = 0; i < SumAN; i++)
  {
    e.X += a[i] * cos(b1);
    e.Y += a[i] * sin(b1);
    std::cout << e.X << " " << e.Y << std::endl;
  }
  long double cosb2 = (End.X - Begin.X) / SumB,
              sinb2 = (End.Y - Begin.Y) / SumB;

  if (sinb2 == 0)
    cosb2 = -1;

  for (int i = SumAN; i < n; i++)
  {
    e.X += a[i] * cosb2;
    e.Y += a[i] * sinb2;
    std::cout << e.X << " " << e.Y << std::endl;
  }
  return 0;
}
// #endif