#include <iostream>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <vector>
using namespace std;

using UINT64 = unsigned long long;
using INT64 = long long;

unsigned long long Power( UINT64 A, UINT64 Power )
{
	UINT64 res = 1;

	for (UINT64 i = 0; i < Power; i++)
		res *= A;

	return res;
}

int main47(void)
{
	UINT64 n, x;
	UINT64 p;

	std::cin >> n >> x;

	p = Power(10, n);

	if (x > p || x < 0)
	{
		cout << "NO";
		return 0;
	}

	cout << "YES" << endl;
	cout << x << ' ' << p;

	return 0;
}

inline INT64 Pow2( INT64 X )
{
	return X * X;
}

inline INT64 Max3( INT64 a, INT64 b, INT64 c)
{
	return max(max(a, b), c);
}

struct card
{
	int f, b;
};

int main(void)
{
	long long n = 0;
	std::vector<card> cards;

	std::cin >> n;
	cards.resize(n);

	for (int i = 0; i < n; i++)
		std::cin >> cards[i].f;

	for (int i = 0; i < n; i++)
		std::cin >> cards[i].b;

	for (auto &i : cards)
	{
		if (i.b < i.f)
			swap(i.b, i.f);
	}

	//int cnt = 0;
	//for (int i = 0; i < n; i++)
	//	if (cards[i].f == cards[0].f)
	//		cnt++;
	//
	//if (cnt != n)
	//{
		std::qsort(cards.data(), n, sizeof(card), [](void const* A, void const* B) -> int
			{
				card* a1 = (card*)A;
				card* a2 = (card*)B;

				return a1->f > a2->f ? 1 : (a1->f < a2->f ? -1 : (a1->b > a2->b ? 1 : (a1->b < a2->b ? -1 : 0)));
			});

		bool flag = true;

		if (cards[n - 1].f > cards[0].b)
			flag = false;

		if (flag)
			for (int i = 1; i < n; i++)
				if (cards[i].b < cards[i - 1].b)
					flag = false;

		if (!flag)
		{
			cout << -1;
			return 0;
		}

		for (int i = 0; i < n; i++)
			std::cout << cards[i].f << ' ';
		std::cout << endl;
		for (int i = 0; i < n; i++)
			std::cout << cards[i].b << ' ';

		return 0;
	//}
	//else
	//{
	//	std::qsort(cards.data(), n, sizeof(card), [](void const* A, void const* B) -> int
	//		{
	//			card* a1 = (card*)A;
	//			card* a2 = (card*)B;
	//
	//			return a1->b > a2->b ? 1 : (a1->b < a2->b ? -1 : 0);
	//		});
	//
	//	for (int i = 0; i < n; i++)
	//		std::cout << cards[i].f << ' ';
	//	std::cout << endl;
	//	for (int i = 0; i < n; i++)
	//		std::cout << cards[i].b << ' ';
	//
	//}
}

int main53( void )
{
	int minn = 1, maxn = 8;
	int minf = 1, maxf = 8;
	int s1 = 1, s2 = 1;


	while (true)
	{
		char x;

		cout << '? ' << s1 << ' ' << s2;
		cin >> x;

		if (x == '+')
		{
			s1++;
			s2++;
			maxn--;
			maxf--;
		}
		else
		{
			s2 = -s2;
			break;
		}
	}

	// s1+ s2-

	while (true)
	{
		char x;

		cout << '? ' << s1 << ' ' << s2;
		cin >> x;

		if (x == '+')
		{
			s1++;
			s2--;
			minn++;
			maxf--;
		}
		else
		{
			s2 = -s2;
			break;
		}
	}

	return 0;

}