#ifdef _MSC_VER
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <map>
#include <set>
#else
#include <bits/stdc++.h>
#endif

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define imax(a, b) a=max(a, b)
#define imin(a, b) a=min(a, b)
#define ld long double
#define str string
#define pii pair<int,int>
#define elif else if
#define vec vector

int gcd(int a, int b) {
	if (a == 0 || b == 0) return a + b;
	return gcd(b, a % b);
}

void print(vec<int> a) {
	for (int i : a) cout << i << ' ';
	cout << '\n';
}

void solve() {
	int n; cin >> n;
	if (n == 1) {
		cout << 1;
		return;
	}
	if (n < 5) {
		cout << -1;
		return;
	}
	if (n % 2 == 0) {
		vec<vec<int>> a(n, vec<int>(n));
		int cur = 1;
		for (int i = 0; i < n / 2; i++) {
			for (int j = 0; j < 2; j++) {
				a[j][i] = cur;
			}
		}
		cur++;
		for (int i = n / 2; i < n; i++) a[0][i] = cur;
		for (int i = 0; i <= n / 2; i++) a[i][n - 1] = cur;
		cur++;
		for (int num = n / 2 + 1, j = n - 2; num < n; num++, j--) {
			for (int i = 1; i <= num; i++) {
				a[i][j] = cur;
			}
			for (int i = num; i < n; i++) {
				a[i][j + 1] = cur;
			}
			cur++;
		}
		for (int num = 1, j = 0; num <= n / 2 - 1; num++, j++) {
			for (int i = 2; i <= num + 1; i++) {
				a[i][j + 1] = cur;
			}
			for (int i = n - 1; i >= n - num; i--) {
				a[i][j + 1] = cur;
			}
			for (int i = 1 + num; i <= n - num; i++) {
				a[i][j] = cur;
			}
			cur++;
		}
		for (auto i : a) print(i);
	}
	else {
		vec<vec<int>> a(n, vec<int>(n));
		int cur = 1;
		for (int i = 0; i < n / 2; i++) {
			a[0][i] = cur;
		}
		for (int i = 0; i < n / 2 + 1; i++) {
			a[1][i] = cur;
		}
		cur++;
		for (int i = n / 2; i < n; i++) a[0][i] = cur;
		for (int i = 1; i < 1 + n / 2; i++) a[i][n - 2] = cur;
		cur++;
		for (int i = 1; i < n; i++) a[i][n - 1] = cur;
		a[1 + n / 2][n - 2] = cur;
		cur++;
		for (int num = n / 2 + 1, j = n - 3; num < n - 1; num++, j--) {
			for (int i = 1; i <= num + 1; i++) {
				a[i][j] = cur;
			}
			for (int i = num + 1; i < n; i++) {
				a[i][j + 1] = cur;
			}
			cur++;
		}
		a[1][n / 2] = 1;
		a[(n - 2) / 2 + 2][n / 2 - 1] = cur - 1;
		for (int num = 1, j = 0; num <= n / 2 - 1; num++, j++) {
			for (int i = 2; i <= num + 1; i++) {
				a[i][j + 1] = cur;
			}
			for (int i = n - 1; i >= n - num; i--) {
				a[i][j + 1] = cur;
			}
			for (int i = 1 + num; i <= n - num; i++) {
				a[i][j] = cur;
			}
			cur++;
		}
		for (auto i : a) print(i);
	}
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout << fixed << setprecision(20);
	int TST = 1;// cin >> TST;
	while (TST--) { solve(); cout << '\n'; }
}