#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;


int main()
{
	ll n, q;
	cin >> n >> q;

	vector<map<ll, ll>> zov(n);
	ll ans = 0;
	while (q--)
	{
		char z;
		cin >> z;

		ll a, b, c;
		cin >> a >> b >> c;
		
		a--;
		b--;

		if (z == '+')
		{
			zov[a][c]++;
			zov[b][c]++;
			if (zov[a][c] == 1 && zov[b][c] == 1)
				ans++;
			else if (zov[a][c] == 2 || zov[b][c] == 2)
				ans--;
		}
		else
		{
			zov[a][c]--;
			zov[b][c]--;
			if (zov[a][c] == 1 && zov[b][c] == 1)
				ans++;
			else if (zov[a][c] == 0 || zov[b][c] == 0)
				ans--;
		}
		cout << ans << '\n';
	}

	return 0;
}