#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b)
{
	while (b != 0)
	{
		a %= b;
		swap(a, b);
	}
	return a;
}

int main()
{
	ll x1, y1, x2, y2, x3, y3;
	cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

	ll a = (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2), b = (x1 - x3) * (x1 - x3) + (y1 - y3) * (y1 - y3), c = (x2 - x3) * (x2 - x3) + (y2 - y3) * (y2 - y3);

	if (a >= b && a >= c)
	{
		ll x4 = x1 + x2, y4 = y1 + y2, nod = gcd(x4, y4);
		cout << 0 << ' ' << 0 << ' ' << x4 / nod << ' ' << y4 / nod;
	}
	else if (c >= b && c >= a)
	{
		ll x4 = x2 + x3, y4 = y2 + y3, nod = gcd(x4, y4);
		cout << 0 << ' ' << 0 << ' ' << x4 / nod << ' ' << y4 / nod;
	}
	else if (b >= a && b >= c)
	{
		ll x4 = x1 + x3, y4 = y1 + y3, nod = gcd(x4, y4);
		cout << 0 << ' ' << 0 << ' ' << x4 / nod << ' ' << y4 / nod;
	}

	return 0;
}