#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <math.h>

typedef  unsigned long long LL;
#define INF 1000000001

void Swap(long long* A, long long* B)
{
  long long tmp = *A;
  *A = *B;
  *B = tmp;
}

void QuickSort(long long *A, long long  N )
{
  long long b, e, x;

  if (N < 2)
    return;

  b = 0;
  e = N - 1;
  x = A[N / 2];
  
  while (b <= e)
  {
    while (A[b] < x)
      b++;
    while (A[e] > x)
      e--;

    if (b <= e)
    {
      if (b != e)
        Swap(&A[b], &A[e]);
      b++;
      e--;
    }
  }
  QuickSort(A, e + 1);
  QuickSort(A + b, N - b);


}

void A(void)
{
  unsigned long long n, k, m = 1;

  scanf("%llu", &n);
  scanf("%llu", &k);

  if (n >= 1000000)
    printf("NO");
  else
  {
    while (n != 0)
      m *= 10, n--;
    printf("YES\n%llu %llu", k, m);
  }
}

LL DReq(LL m, LL n, LL s, LL res)
{
  if (s == m * n)
    return(res);
  else if (s % n == 0 || s % m == 0)
    return(res + 1);
  else if (m * n % s == 0 || m > s || n > s)
    return(res + 2);
  else
  {
    if (m - s / n == 1 || s % (m - s / n) == 0 )
    {
      res += 1;
      m -= s / n;
      res = DReq(m, n, s - s / n * n, res);
    }
    else 
    {
      res += 1;
      n -= s / m;
      res = DReq(m, n, s - s / m * m, res);
    }
    return (res);
  }
}            
void D(void)
{
  LL m, n, s, res = 0;

  scanf("%llu", &m);
  scanf("%llu", &n);
  scanf("%llu", &s);

  printf("%llu", DReq(m, n, s, res));
}

long long Max(long long a, long long b, long long c)
{
  if (a >= b)
    if (a >= c)
      return a;
    else
      return c;
  else
    if (c >= b)
      return c;
    else
      return b;

}

void M(void)
{
  long long a, b, c, x1, x2, x3, y1, y2, y3, max;

  scanf("%lld %lld %lld %lld %lld %lld", &x1, &y1, &x2, &y2, &x3, &y3);

  a = (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
  b = (x2 - x3) * (x2 - x3) + (y2 - y3) * (y2 - y3);
  c = (x1 - x3) * (x1 - x3) + (y1 - y3) * (y1 - y3);
  
  max = Max(a, b, c);

  if (a == max)
    printf("%lld %lld %lld %lld", x1, y1, x2, y2);
  if (b == max)
    printf("%lld %lld %lld %lld", x2, y2, x3, y3);
  if (c == max)
    printf("%lld %lld %lld %lld", x1, y1, x3, y3);

  return;
}

int main(void)
{ 
  D();
  //long long A[10] = {5, 2, 0, 34, 1, 6, 8, 3, 2, 12};
  //QuickSort(A, 2);



  return 0;
}