#include <iostream>
#include <cmath>
#define ll long long
using namespace std;

bool can(ll s, ll n, ll m) {
	if ((n * m - n * (s / n)) / n == s)
		return true;
	return false;
}

bool can2_type1(ll s, ll n, ll m) {
	if (n * m - n * (s / n) == n or m * n - m * (s / m) == m)
		return true;
	ll m1 = (m * n - m * (s / m)) / n, n1 = (n * m - n * (s / n)) / m;
	ll ostm = s % m, ostn = s % n;
	return (m1 != 0 and ostm % m1 == 0) or (n1 != 0 and ostn % n1 == 0);
}

bool can2_type2(ll s, ll n, ll m) {
	ll d = 2, g = 1;
	while (s != 1) {
		while (s % d)
			d++;
		while (s != 0 and s % d == 0) {
			ll a = g * d;
			ll b = s / a;
			if (a <= n and b <= m or a <= m and b <= n)
				return true;
			s /= d;
			g *= d;
		}
	}
	return false;
}

int main()
{
	ll m, n, s;
	cin >> m >> n >> s;
	if (m * n == s)
		cout << 0;
	else if (s % n == 0 or s % m == 0)
		cout << 1;
	else {
		if (s == 1 or can2_type1(s, n, m) or can2_type2(s, n, m))
			cout << 2;
		else
			cout << 3;
	}
}