#define _USE_MATH_DEFINES

#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("popcnt,avx,avx2,fma,bmi,bmi2")

using namespace std;

template<typename T1, typename T2>
istream& operator>>(istream &in, pair<T1, T2>& p) {
    in >> p;
    return in;
}

template<typename T1, typename T2>
ostream& operator<<(ostream &os, pair<T1, T2>& p) {
    os >> p;
    return os;
}


template<typename T1>
istream& operator>>(istream &in, vector<T1>& p) {
    for (auto& i : p) {
        in >> i;
    }
    return in;
}

template<typename T1>
ostream& operator<<(ostream &os, vector<T1>& p) {
    for (auto& i : p) {
        cout << i << ' ';
    }
    return os;
}

mt19937_64 rnd64(239);
mt19937 rnd(239);

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using str = string;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define null nullptr
//#define int ll

#define fast cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);
#define file(a, b, c) freopen(a, "r", stdin); freopen(b, "w", stdout); freopen(c, "w", stderr);
#define many int _; cin >> _; while(_--)
#define p_b push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define minus1(x) for (auto& _ : x) _--
#define plus1(x) for (auto& _ : x) _++

const int INT_INF = INT_MAX;
const ll LL_INF = LONG_LONG_MAX;
const ld EPS = 1e-7;


signed main() {
#ifdef LOCAL
    file("inp.txt", "out.txt", "err.txt")
#endif
    fast

    ll n, m;
    ll s;
    cin >> n >> m >> s;
    if (s == 1ll * n * m) {
        cout << 0;
        return 0;
    }
    if (s % n == 0 || s % m == 0) {
        cout << 1;
        return 0;
    }
    for (ll i = 1; i <= n; i++) {
        ll l = 0, r = m + 1;
        while (l + 1 < r) {
            ll mid = (l + r) / 2;
            if (m * n - mid * i > s) {
                l = mid;
            }else if (m * n - mid * i < s) {
                r = mid;
            }else {
                cout << 2;
                return 0;
            }
        }
    }

    for (ll i = 1; i <= n; i++) {
        ll l = 0, r = m + 1;
        if (2 * i < n) {
            while (l + 1 < r) {
                ll mid = (l + r) / 2;
                if (m * n - i * m - n * mid + 2 * mid * i > s) {
                    l = mid;
                } else if (m * n - i * m - n * mid + 2 * mid * i < s) {
                    r = mid;
                } else {
                    cout << 2;
                    return 0;
                }
            }
        }else {
            while (l + 1 < r) {
                ll mid = (l + r) / 2;
                if (m * n - i * m - n * mid + 2 * mid * i > s) {
                    r = mid;
                } else if (m * n - i * m - n * mid + 2 * mid * i < s) {
                    l = mid;
                } else {
                    cout << 2;
                    return 0;
                }
            }
        }
    }
    cout << 3;
}
