#define _USE_MATH_DEFINES

#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("popcnt,avx,avx2,fma,bmi,bmi2")

using namespace std;

template<typename T1, typename T2>
istream& operator>>(istream &in, pair<T1, T2>& p) {
    in >> p;
    return in;
}

template<typename T1, typename T2>
ostream& operator<<(ostream &os, pair<T1, T2>& p) {
    os >> p;
    return os;
}


template<typename T1>
istream& operator>>(istream &in, vector<T1>& p) {
    for (auto& i : p) {
        in >> i;
    }
    return in;
}

template<typename T1>
ostream& operator<<(ostream &os, vector<T1>& p) {
    for (auto& i : p) {
        cout << i << ' ';
    }
    return os;
}

mt19937_64 rnd64(239);
mt19937 rnd(239);

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using str = string;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define null nullptr
//#define int ll

#define fast cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);
#define file(a, b, c) freopen(a, "r", stdin); freopen(b, "w", stdout); freopen(c, "w", stderr);
#define many int _; cin >> _; while(_--)
#define p_b push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define minus1(x) for (auto& _ : x) _--
#define plus1(x) for (auto& _ : x) _++

const int INT_INF = INT_MAX;
const ll LL_INF = LONG_LONG_MAX;
const ld EPS = 1e-7;


struct vec {
    int x, y;

    vec() : x(0), y(0) {}
    vec(vec &a, vec &b) : x(b.x - a.x), y(b.y - a.y) {}

    ld len() {
        return sqrtl(1ll * x * x + 1ll * y * y);
    }
};

ll operator%(vec a, vec b) {
    return 1ll * a.x * b.y - 1ll * a.y * b.x;
}


ld solve(vec &a, vec &b, vec &c) {
    return abs((ld) (vec(a, b) % vec(a, c)) / vec(a, b).len());
}


signed main() {
#ifdef LOCAL
    file("inp.txt", "out.txt", "err.txt")
#endif
    fast


    vec a, b, c;
    cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y;

    vector<ld> ans;
    ans.p_b(solve(a, b, c));
    ans.p_b(solve(a, c, b));
    ans.p_b(solve(b, c, a));

    int mn = min_element(all(ans)) - ans.begin();
    if (mn == 0) {
       cout << a.x << " " << a.y << " " << b.x << " " << b.y;
    } else if (mn == 1) {
        cout << a.x << " " << a.y << " " << c.x << " " << c.y;
    } else {
        cout << c.x << " " << c.y << " " << b.x << " " << b.y;
    }
}