import math


def count_dist(x1, y1, x2, y2):
    A = y1 - y2
    B = - (x1 - x2)
    C = x1*y2 - x2*y1

    d = A**2 + B**2 + C**2

    return A, B, C, d


x1, y1, x2, y2, x3, y3 = map(int, input().split())
l1 = count_dist(x1, y1, x2, y2)
l2 = count_dist(x2, y2, x3, y3)
l3 = count_dist(x3, y3, x1, y1)

d1 = (l1[0] * x3 + l1[1] * y3 + l1[2]) ** 2 * l2[-1] * l3[-1]
d2 = (l2[0] * x1 + l2[1] * y1 + l2[2]) ** 2 * l1[-1] * l3[-1]
d3 = (l3[0] * x2 + l3[1] * y2 + l3[2]) ** 2 * l1[-1] * l2[-1]


if min(d1, d2, d3) == d1:
    print(x1, y1, x2, y2)
elif min(d1, d2, d3) == d2:
    print(x2, y2, x3, y3)
else:
    print(x3, y3, x1, y1)
