#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;
template<typename T>
using ordered_set = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

void _solve(int x, int y, int n, bool start) {
    if (n == 3) {
        if (start) cout << 2 << ' ' << 2 << '\n';

        cout << 0 + x << ' ' << 0 + y << '\n';
        cout << 3 + x << ' ' << 0 + y << '\n';
        cout << 0 + x << ' ' << 3 + y << '\n';
        cout << 0 + x << ' ' << 1 + y << '\n';
    } else if (n == 4) {
        if (start) cout << 0 << ' ' << 0 << '\n';
        cout << 3 + x << ' ' << 0 + y << '\n';
        cout << 3 + x << ' ' << 4 + y << '\n';
        _solve(x + 0, y + 1, n - 1, false);
    } else {
        if (n % 2 == 1) {
            if (start) cout << n - 1 << ' ' << n - 1 << '\n';
            cout << 0 + x << ' ' << n - 1 + y << '\n';
            cout << 0 + x << ' ' << 0 + y << '\n';
            _solve(x + 1, y + 0, n - 1, false);
        } else {
            if (start) cout << 0 << ' ' << 0 << '\n';
            cout << n - 1 + x << ' ' << 0 + y << '\n';
            cout << n - 1 + x << ' ' << n - 1 + y << '\n';
            _solve(x, y + 1, n - 1, false);
        }
    }
}

void solve() {
    int n;
    cin >> n;
    _solve(0, 0, n, true);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}