#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;
template<typename T>
using ordered_set = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int dx = 0, dy = 0;
    auto query = [&](int x, int y) {
        cout << '?' << ' ' << x << ' ' << y << endl;
        char c;
        cin >> c;
        if (c == '+') {
            dx += x;
            dy += y;
            return true;
        } else {
            return false;
        }
    };


    int v1 = 0, v2 = 0;
    for (int i = 4; i > 0; i /= 2) if (query(i, -i)) v1 += i;

    if (query(1, 1)) {
        v2++;
        for (int i = 4; i > 0; i /= 2) if(query(i, i)) v2 += i;

        int x = 7 - dx;
        int y = v2 - dy;
        cout << '!' << ' ' << char('a' + x) << y + 1 << '\n';
    } else {
        for (int i = 4; i > 0; i /= 2) if(query(-i, -i)) v2 += i;
        int x = 7 - v2 - dx;
        int y = 0 - dy;
        cout << '!' << ' ' << char('a' + x) << y + 1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}