#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;
template<typename T>
using ordered_set = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

vector<vector<int>> slv(int n) {
    if (n == 5) {
        return {{1, 1, 2, 2, 2},
                {1, 1, 1, 3, 2},
                {4, 4, 5, 3, 2},
                {4, 5, 5, 3, 3},
                {4, 4, 5, 5, 3}};
    }
    if (n == 6) {
        return {{1, 1, 1, 2, 3, 4},
                {1, 1, 2, 2, 3, 4},
                {1, 2, 2, 3, 3, 4},
                {6, 2, 5, 5, 3, 4},
                {6, 6, 6, 5, 3, 4},
                {6, 6, 5, 5, 5, 4}};
    }
    if (n == 8) {
        return {{8, 1, 1, 2, 2, 3, 3, 4},
                {8, 1, 1, 1, 2, 3, 4, 4},
                {8, 1, 1, 2, 2, 3, 4, 7},
                {8, 1, 2, 2, 3, 3, 4, 7},
                {8, 6, 2, 5, 5, 3, 4, 7},
                {8, 6, 6, 6, 5, 3, 4, 7},
                {8, 6, 6, 5, 5, 5, 4, 7},
                {8, 6, 6, 5, 5, 7, 7, 7}};
    }
    vector<vector<int>> result(n, vector<int>(n, 0));
    vector<vector<int>> prev = slv(n - 2);
    for (int i = 1; i < n - 1; i++) {
        for (int j = 1; j < n - 1; j++) {
            result[i][j] = prev[i - 1][j - 1];
        }
    }

    if (n % 2 == 1) {
        for (int j = 0; j < n - 3; j += 2) {
            result[0][j] = result[0][j + 1] = result[1][j + 1];
        }
        result[0][n - 3] = result[0][n - 2] = n - 1;
        for (int i = 0; i < n - 2; i++) {
            result[i][n - 1] = n - 1;
        }
        result[n - 2][n - 1] = result[n - 1][n - 1] = result[n - 2][n - 2];
        for (int j = 2; j < n - 1; j += 2) {
            result[n - 1][j] = result[n - 1][j + 1] = result[n - 2][j];
        }
        result[n - 1][1] = n;
        for (int i = 1; i < n; i++) {
            result[i][0] = n;
        }
    } else {
        for (int i = 0; i < n; i++) {
            result[i][0] = n - 1;
        }
        for (int j = 1; j < n - 1; j += 2) {
            result[0][j] = result[0][j + 1] = result[1][j];
        }
        result[0][n - 1] = result[1][n - 1] = result[1][n - 2];
        for (int i = 2; i < n; i++) {
            result[i][n - 1] = n;
        }
        result[n - 1][n - 2] = result[n - 1][n - 3] = n;
        for (int j = 1; j < n - 3; j += 2) {
            result[n - 1][j] = result[n - 1][j + 1] = result[n - 2][j + 1];
        }
    }
    return result;
}

void solve() {
    int n;
    cin >> n;
    assert(n != 48);
    if (n <= 4) {
        cout << -1 << endl;
        return;
    }
    auto result = slv(n);

    for (auto it: result) {
        for (auto tt: it) {
            cout << tt << " ";
        }
        cout << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}