#include <iostream>
#include <vector>
#include <iomanip>
using namespace std;

using ld = long double;
using ll = long long;

int main() {
	int n;
	ll m, c;
	cin >> n >> m >> c;
	vector<ll> x(n + 2);
	vector<ll> t(n + 2);
	x[0] = 0;
	t[0] = 0;
	x[n + 1] = m;
	t[n + 1] = 0;
	for (int i = 1; i <= n; i++) {
		cin >> x[i];
		cin >> t[i];
		t[i] *= c;
	}
	vector<ll> dp(n + 2);
	dp[0] = 0;
	int last = 0;
	for (int i = 1; i <= n + 1; i++) {
		dp[i] = t[i];
		ll addl = dp[last] + (x[i] - x[last]) * (x[i] - x[last]);
		ll addi = dp[i - 1] + (x[i] - x[i - 1]) * (x[i] - x[i - 1]);
		if (addi < addl) {
			dp[i] += addi;
			last = i - 1;
		} else {
			dp[i] += addl;
		}
	}
	cout << setprecision(20) << fixed;
	cout << (ld)dp[n + 1] / (ld)c;
}