#include <bits/stdc++.h>

using namespace std;
#define int long long

bool ask(int x, int y) {
    if (x == 0 || y == 0){
        return true;
    }
    cout << "? " << x << " " << y << endl;
    char c;
    cin >> c;
    return (c == '+');
}

int bin1() {
    int dist = 0;
    int l = 0, r = 8;
    while (r - l > 1) {
        int m = (r + l + 1) / 2;
        int x = m - dist;
        if (ask(-x, -x)) {
            dist = m;
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

int bin2(int add) {
    int dist = -add;
    int l = 0, r = 8;
    while (r - l > 1) {
        int m = (r + l + 1) / 2;
        int x = m - dist;
        if (ask(x, x)) {
            dist = m;
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

void solve() {
    int a = bin1();
    int b = bin2(a);
    bool flag = !ask(1, -1 );
    for (int i = 1; i <= 8; ++i) {
        for (int j = 1; j <= 8; ++j) {
            int c = min(i, j) - 1;

            int d = min(9 - i, 9 - j) - 1;

            if (a == c && b == d) {
                if ((flag && i >= j) || (!flag && i < j)) {
                    cout << "! " << char('a' + j - 1) << i << endl;
                    return;
                }
            }
        }
    }
}

/*
+
 -
 -
 -
 -
 +
 */

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(15);

    solve();

/*
    int n;
    cin >> n;
    vector<vector<int>> arr(n, vector<int>(n, 0));
    for (int i = 0; i < n; ++i) {
        arr[0][i] = 1;
    }
    for (int i = 1; i < n; ++i) {
        arr[i][0] = 2;
    }
    arr.back()[1] = 2;
    for (int i = 2; i < n; ++i) {
        arr.back()[i] = 3;
    }
    arr[n - 2][n - 1] = 3;
    arr[n - 3][n - 1] = 3;
    for (int i = 1; i < n - 3; ++i) {
        arr[i][n - 1] = 4;
    }
    arr[1][n - 2] = 4;
    arr[1][n - 3] = 4;
    arr[1][n - 4] = 4;
    arr[2][n - 4] = 4;
    for (int i = 1; i < n - 1; ++i) {
        arr[i][1] = 5;
    }
    arr[n - 2][2] = 5;
    arr[n - 3][2] = 5;
    for (int i = 2; i <= n - 5; ++i) {

    }*/
    return 0;
}

/*



*/
