#include <bits/stdc++.h>

#define x first
#define y second

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using pld = pair<ll, ll>;
const ll mx = 1e6;

ld operator^(pld A, pld B) {
    return A.x * B.y - A.y * B.x;
}

ld operator*(pld A, pld B) {
    return A.x * B.x + A.y * B.y;
}

pld operator-(pld A, pld B) {
    return {A.x - B.x, A.y - B.y};
}

pld operator-(pld A) {
    return {A.x * -1, A.y * -1};
}

ostream& operator<<(ostream& out, pld A) {
    out << A.x << ' ' << A.y;
    return out;
}

ld mod(pld A) {
    return hypot((ld)A.x, (ld)A.y);
}

void solve() {
    ll x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> y3;

    pld A = {x1, y1};
    pld B = {x2, y2};
    pld C = {x3, y3};
    pld AB = B - A;
    pld BC = C - B;
    pld AC = C - A;
    ld d1 = mod(A - B);
    ld d2 = mod(A - C);
    ld d3 = mod(B - C);
    ld mn = min({d1, d2, d3});
    if (mn == d1) {
        cout << A << ' ' << B << '\n';
    } else if(mn == d2) {
        cout << A << ' ' << C << '\n';
    } else {
        cout << B << ' ' << C << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    t = 1;

    while (t--) {
        solve();
    }
    return 0;
}
