#include <bits/stdc++.h>

using namespace std;

/*#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,bmi2,fma")*/

//#define int long long
//#define double long double

long long inf = (long long) (1ll * 1000 * 1000 * 1000 * 1000 * 1000 * 1000 + 10);

struct otr {
    double l, r;
};

struct line{
    double k, b;
};

vector<otr> diap;
vector<line> cht;
int sz;

double get(double x) {
    int l = 0;
    int r = sz;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (diap[m].l <= x) {
            l = m;
        } else {
            r = m;
        }
    }
    return cht[l].k * x + cht[l].b;
}

void update(double k, double b) {
    while (true) {
        if (sz == 0) {
            diap[sz] = {(double)(0), (double)inf};
            cht[sz] = {k, b};
            sz++;
            break;
        }
        double k1, b1;
        k1 = cht[sz - 1].k;
        b1 = cht[sz - 1].b;
        double x_per = max((double)(0), (b1 - b) / (k - k1));
        if ((x_per > diap[sz - 1].l) && (x_per <= (double)inf)) {
            diap[sz - 1].r = x_per;
            diap[sz] = {x_per, (double)inf};
            cht[sz] = {k, b};
            sz++;
            break;
        } else {
            sz--;
        }
    }
}

void solve()
{
    int n, m;
    double c;
    cin >> n >> m >> c;
    vector<double> x(n + 2);
    vector<double> t(n + 2);
    for (int i = 0; i < n; i++) {
        cin >> x[i + 1] >> t[i + 1];
    }
    x[0] = 0;
    x[n + 1] = m;
    t[0] = 0;
    t[n + 1] = 0;
    diap.resize(n + 4);
    cht.resize(n + 4);
    diap[0] = {(double)(0), (double)inf};
    vector<double> dp(n + 2);
    dp[0] = 0;
    cht[0] = {0, 0};
    sz = 1;
    for (int i = 1; i <= n + 1; i++) {
        dp[i] = get(x[i]) + x[i] * x[i] / c + t[i];
        update(-2 * x[i] / c, (dp[i] + x[i] * x[i] / c));
    }
    cout.precision(30);
    cout << dp[n + 1] << "\n";
}

signed main()
{
#ifdef Lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int _ = 1;
    //cin >> _;
    while (_--)
    {
        solve();
    }
}
