#include <bits/stdc++.h>
#define int long long
#define ld long double
#define p pair<int, int>
#define endl '\n'
const int INF = (int)1e9+1;

using namespace std;

vector<vector<int>> ans;

void small(int n) {
    if (n == 1) {
        ans = {{1}};
    } else if (n == 5) {
        ans = {{4, 4, 2, 2, 2},
               {4, 4, 4, 2, 3},
               {5, 5, 1, 2, 3},
               {5, 1, 1, 3, 3},
               {5, 5, 1, 1, 3}};
    }
}

void big(int n) {
    int mid_l = (n-1)/2, mid_r = n/2;
    ans.assign(n, vector<int>(n, n));
    int ind = 1;
    for (int q = 0; q < mid_l; q++) {
        for (int q1 = 0; q1 < n-2; q1++) {
            int q2 = q+(ans[q][q1] == ind-1);
            ans[q2][q1] = ind;
        }
        ans[q+1][mid_l-1-q] = ans[q+1][mid_r-1+q] = ind++;
    }
    for (int q = 0; q <= mid_l; q++) {
        ans[q][n-2] = ans[q][n-1] = ind;
    }
    ans[0][n-2] = (n % 2 == 0 ? ind : 1);
    for (int q = mid_l+1; q < n-1; q++) {
        ind++;
        for (int q1 = 0; q1 < q-mid_l; q1++) {
            ans[q+1][q1] = ind;
        }
        for (int q1 = q-mid_l-1; q1 < n-1; q1++) {
            ans[q][q1] = ind;
        }
    }
    assert(ind == n-1);
}

mt19937 randint(17957179);

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    if (n <= 5) {
        small(n);
    } else {
        big(n);
    }
    if (ans.empty()) {
        cout << -1 << endl;
        return 0;
    }
    if (n % 4 == 0) {
        int x1 = randint() % n, y1 = randint() % n;
        int x2 = randint() % n, y2 = randint() % n;
        swap(ans[x1][y1], ans[x2][y2]);
    } else if (n % 3 == 0) {
        int x = randint() % n, y = randint() % n, c = randint() % n+1;
        ans[x][y] = c;
    }
    for (auto& q : ans) {
        for (int q1 : q) {
            cout << q1 << ' ';
        }
        cout << endl;
    }
    return 0;
}
