#include <iostream>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <vector>
using namespace std;

using UINT64 = unsigned long long;
using INT64 = long long;

unsigned long long Power( UINT64 A, UINT64 Power )
{
	UINT64 res = 1;

	for (UINT64 i = 0; i < Power; i++)
		res *= A;

	return res;
}

int main47(void)
{
	UINT64 n, x;
	UINT64 p;

	std::cin >> n >> x;

	p = Power(10, n);

	if (x > p || x < 0)
	{
		cout << "NO";
		return 0;
	}

	cout << "YES" << endl;
	cout << x << ' ' << p;

	return 0;
}

inline INT64 Pow2( INT64 X )
{
	return X * X;
}

inline INT64 Max3( INT64 a, INT64 b, INT64 c)
{
	return max(max(a, b), c);
}

struct card
{
	int f, b;
};

int main(void)
{
	long long n = 0;
	std::vector<card> cards;
	int f;

	std::cin >> n;
	cards.resize(n);

	for (int i = 0; i < n; i++)
		std::cin >> cards[i].f;

	for (int i = 0; i < n; i++)
		std::cin >> cards[i].b;

	for (auto &i : cards)
	{
		if (i.b > i.f)
			swap(i.b, i.f);
	}

	std::qsort(cards.data(), n, sizeof(card), [](void const* A, void const* B) -> int
		{
			card* a1 = (card*)A;
			card* a2 = (card*)B;

			return (a1->b > a2->b) ? 1 : (a1->b < a2->b) ? -1 : 0;
		});

	bool f1 = true;
	int old = cards[n - 1].b;

	for (int i = 0; i < n; i++)
		if (cards[i].f < old)
		{
			f1 = false;
			break;
		}
		else
			old = cards[i].f;

	if (!f1)
	{
		cout << -1;
		return 0;
	}

	for (int i = 0; i < n; i++)
		std::cout << cards[i].b << ' ';
	std::cout << endl; 
	for (int i = 0; i < n; i++)
		std::cout << cards[i].f << ' ';

 	return 0;
}