#include <iostream>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <vector>
using namespace std;

using UINT64 = unsigned long long;
using INT64 = long long;

unsigned long long Power( UINT64 A, UINT64 Power )
{
	UINT64 res = 1;

	for (UINT64 i = 0; i < Power; i++)
		res *= A;

	return res;
}

int main47(void)
{
	UINT64 n, x;
	UINT64 p;

	std::cin >> n >> x;

	p = Power(10, n);

	if (x > p || x < 0)
	{
		cout << "NO";
		return 0;
	}

	cout << "YES" << endl;
	cout << x << ' ' << p;

	return 0;
}

inline INT64 Pow2( INT64 X )
{
	return X * X;
}

inline INT64 Max3( INT64 a, INT64 b, INT64 c)
{
	return max(max(a, b), c);
}

struct card
{
	int f, b;
};

int main(void)
{
	long long n = 0;
	std::vector<card> cards;

	std::cin >> n;
	cards.resize(n);

	for (int i = 0; i < n; i++)
		std::cin >> cards[i].f;

	for (int i = 0; i < n; i++)
		std::cin >> cards[i].b;

	for (auto &i : cards)
	{
		if (i.b < i.f)
			swap(i.b, i.f);
	}

	//int cnt = 0;
	//for (int i = 0; i < n; i++)
	//	if (cards[i].f == cards[0].f)
	//		cnt++;
	//
	//if (cnt != n)
	//{
		std::qsort(cards.data(), n, sizeof(card), [](void const* A, void const* B) -> int
			{
				card* a1 = (card*)A;
				card* a2 = (card*)B;

				return a1->f > a2->f ? 1 : (a1->f < a2->f ? -1 : (a1->b > a2->b ? 1 : (a1->b < a2->b ? -1 : 0)));
			});

		bool flag = true;

		//if (cards[n - 1].f > cards[0].b)
		//	flag = false;

		if (flag)
			for (int i = 1; i < n; i++)
				if (cards[i].b < cards[i - 1].b)
					flag = false;

		if (!flag)
		{
			cout << -1;
			return 0;
		}

		for (int i = 0; i < n; i++)
			std::cout << cards[i].f << ' ';
		std::cout << endl;
		for (int i = 0; i < n; i++)
			std::cout << cards[i].b << ' ';

		return 0;
	//}
	//else
	//{
	//	std::qsort(cards.data(), n, sizeof(card), [](void const* A, void const* B) -> int
	//		{
	//			card* a1 = (card*)A;
	//			card* a2 = (card*)B;
	//
	//			return a1->b > a2->b ? 1 : (a1->b < a2->b ? -1 : 0);
	//		});
	//
	//	for (int i = 0; i < n; i++)
	//		std::cout << cards[i].f << ' ';
	//	std::cout << endl;
	//	for (int i = 0; i < n; i++)
	//		std::cout << cards[i].b << ' ';
	//
	//}
}

int main1321( void )
{
	char sign;
	int sum = 0;
	int v, u, c, n, q;
	int cnt = 0;
	int check = 1;
	std::vector <std::vector<int>> graf;
	
	std::cin >> n >> q;

	graf.resize(n);

	for (auto &gr : graf)
	{
		gr.resize(n);
		memset(gr.data(), 0, sizeof(int) * n);
	}

	for (int i = 0; i < q; i++)
	{
		cin >> sign >> v >> u >> c;

		for (int j = 0; j < v - 1; j++)
		{
			if (graf[j][u - 1] == c)
			{
				cnt++;
			}	
		}
		if (cnt == 1)
		{
			cnt = 0;
			for (int j = 0; j < u - 1; j++)
			{
				if (graf[v - 1][j] == c)
				{
					cnt++;
				}
			}
			if (cnt > 1)
			{
				check = -1;
			}
		}

		else if (cnt > 1)
		{
			check = -1;
		}

		cnt = 0;

		if (sign == '+')
		{
			graf[v - 1][u - 1] = c;
			graf[u - 1][v - 1] = c;
		}
		else if (sign == '-')
		{
			graf[v - 1][u - 1] = 0;
			graf[u - 1][v - 1] = 0;
		}

		for (int j = 0; j < v - 1; j++)
		{
			if (graf[j][u - 1] == c)
			{
				cnt++;
			}
		}

		if (cnt == 1)
		{
			cnt = 0;

			for (int j = 0; j < u - 1; j++)
			{
				if (graf[v - 1][j] == c)
				{
					cnt++;
				}
			}
			if (cnt > 1)
			{
				sum += check;
			}
		}
		else if (cnt > 1)
		{
			sum += check;
		}

		check = 1;
		cnt = 0;

		cout << sum;
	}

	return 0;
}