#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

bool by_sum(pair<int, int> a, pair<int, int> b) {
    return a.first + a.second < b.first + b.second;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int n; cin >> n;
    vector<pair<int, int>> cards(n);
    for (auto &i : cards) cin >> i.first;
    for (auto &i : cards) cin >> i.second;
    sort(cards.begin(), cards.end(), by_sum);

    vector<pair<int, int>> res(n);
    res[0] = cards[0];
    for (int i = 1; i < n; i++) {
        if (res[i-1].first <= cards[i].first && res[i-1].second <= cards[i].second) {
            res[i] = cards[i];
        } else if (res[i-1].first <= cards[i].second && res[i-1].second <= cards[i].first) {
            res[i].first = cards[i].second;
            res[i].second = cards[i].first;
        } else {
            cout << "-1\n";
            return 0;
        }
    }
    for (auto e: res) cout << e.first << ' ';
    cout << '\n';
    for (auto e: res) cout << e.second << ' ';
    cout << '\n';
}