#include <iostream>

using namespace std;
using ll = long long;

ll dist(ll x1, ll y1, ll x2, ll y2) {
    return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
}

void print(ll a, ll b, ll c, ll d) {
    cout << a << " " << b << " " << c << " " << d << "\n";
}

int main() {
    ll x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    ll d12 = dist(x1, y1, x2, y2),
       d13 = dist(x1, y1, x3, y3),
       d23 = dist(x2, y2, x3, y3);
    if (d12 >= d13 && d12 >= d23)
        print(x1, y1, x2, y2);
    else if (d13 >= d12 && d13 >= d23)
        print(x1, y1, x3, y3);
    else
        print(x2, y2, x3, y3);
}