#include<bits/stdc++.h>

using namespace std;
using ll = long long;
using ld=long double;

bool cmp(pair<ll, ll>& a, pair<ll, ll>& b){
    return a.first+a.second>b.first+b.second;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n;
    cin>>n;
    vector<ll> a(n);
    vector<ll> b(n);
    for(ll i=0; i<n; ++i){
        cin>>a[i];
    }
    for(ll i=0; i<n; ++i){
        cin>>b[i];
    }
    vector<pair<ll, ll>> cards(n);
    for(ll i=0; i<n; ++i){
        cards[i]={a[i], b[i]};
    }
    sort(cards.begin(), cards.end(), cmp);
    for(ll i=1; i<n; ++i){
        if(max(cards[i-1].first, cards[i-1].second)==cards[i-1].first){
            if(max(cards[i].first, cards[i].second)==cards[i].second){
                swap(cards[i].first, cards[i].second);
            }
        }else{
            if(max(cards[i].first, cards[i].second)==cards[i].first){
                swap(cards[i].first, cards[i].second);
            }
        }
    }

    reverse(cards.begin(), cards.end());
    bool flg=true;
    for(ll i=0; i<n-1; ++i){
        if(cards[i].first>cards[i+1].first){
            flg=false;
            break;
        }
        if(cards[i].second>cards[i+1].second){
            flg=false;
            break;
        }
    }
    if(!flg){
        cout<<-1;
        return 0;
    }
    for(ll i=0; i<n; ++i){
        cout<<cards[i].first<<' ';
    }
    cout<<'\n';
    for(ll i=0; i<n; ++i){
        cout<<cards[i].second<<' ';
    }

    return 0;
}