#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>

using namespace std;

typedef long long ll;


int main()
{
	ll n, m, s;
	cin >> n >> m >> s;

	vector<pair<ll, ll>> z;
	for (ll i = 1; i * i <= s; i++)
		if (!(s % i))
			z.push_back({ i, s / i });
	
	ll ans = 1e18;
	for (pair<ll, ll> i : z)
		if (i.first <= n && i.second <= m)
			ans = min(ans, n - i.first + m - i.second);
		else if (i.first <= m && i.second <= n)
			ans = min(ans, m - i.first + n - i.second);
	cout << min(ans, n - 1 + m - 1);
	return 0;
}