#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

bool check(vector<vector<int>>& arr) {
	int n = arr.size();
	for (int i = 1; i < n; ++i) {
		if (arr[i - 1][0] > arr[i][0] || arr[i - 1][1] > arr[i][1]) {
			return 0;
		}
	}
	return 1;
}

int main()
{
	int n;
	cin >> n;
	vector < vector<int> > arr(n, vector<int>(2));
	for (int i = 0; i < n; ++i) {
		cin >> arr[i][0];
	}
	for (int i = 0; i < n; ++i) {
		cin >> arr[i][1];
	}
	sort(arr.begin(), arr.end());
	for (int _ = 0; _ < 10; ++_) {
		for (int i = 1; i < n; ++i) {
			if (arr[i - 1][1] > arr[i][1]) swap(arr[i][0], arr[i][1]);
		}
		sort(arr.begin(), arr.end());
		if (check(arr)) {
			for (int i = 0; i < n; ++i) cout << arr[i][0] << " ";
			cout << endl;
			for (int i = 0; i < n; ++i) cout << arr[i][1] << " ";
			return 0;
		}
	}
	
	cout << -1;

}