#define _USE_MATH_DEFINES

#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("popcnt,avx,avx2,fma,bmi,bmi2")

using namespace std;

template<typename T1, typename T2>
istream& operator>>(istream &in, pair<T1, T2>& p) {
    in >> p;
    return in;
}

template<typename T1, typename T2>
ostream& operator<<(ostream &os, pair<T1, T2>& p) {
    os >> p;
    return os;
}


template<typename T1>
istream& operator>>(istream &in, vector<T1>& p) {
    for (auto& i : p) {
        in >> i;
    }
    return in;
}

template<typename T1>
ostream& operator<<(ostream &os, vector<T1>& p) {
    for (auto& i : p) {
        cout << i << ' ';
    }
    return os;
}

mt19937_64 rnd64(239);
mt19937 rnd(239);

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using str = string;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define null nullptr
//#define int ll

#define fast cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);
#define file(a, b, c) freopen(a, "r", stdin); freopen(b, "w", stdout); freopen(c, "w", stderr);
#define many int _; cin >> _; while(_--)
#define p_b push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define minus1(x) for (auto& _ : x) _--
#define plus1(x) for (auto& _ : x) _++

const int INT_INF = INT_MAX;
const ll LL_INF = LONG_LONG_MAX;
const ld EPS = 1e-7;


struct line {
    ll k, b;

    line(ll k, ll b) : k(k), b(b) {}
    ll get(ll x) {
        return x * k + b;
    }
};

ld get_inter(line &l1, line &l2) {
    return (ld) (l2.b - l1.b) / (l1.k - l2.k);
}

vector<pair<line, ld>> st;

void add(line new_l) {
    while (true) {
        ld inter = get_inter(st.back().first, new_l);
        if (inter <= st.back().second) {
            st.pop_back();
        } else {
            st.p_b({new_l, inter});
            break;
        }
    }
}

ll get(ll x) {
    int l = 0, r = (int) st.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (st[m].second <= x) {
            l = m;
        } else {
            r = m;
        }
    }
    return st[l].first.get(x);
}


signed main() {
#ifdef LOCAL
    file("inp.txt", "out.txt", "err.txt")
#endif
    fast

    int n;
    cin >> n;
    vector<vector<int>> v(n, vector<int>(n));
    if (n == 1) {
        cout << 1;
    }else
    if (n > 1 && n <= 4) {
        cout << -1;
    }else if (n == 5) {
        cout << "4 4 2 2 2\n"
                "4 4 4 2 3\n"
                "5 5 1 2 3\n"
                "5 1 1 3 3\n"
                "5 5 1 1 3";
    }else {
        if (((n + 1) / 2) % 2 == 0) {
            for (int i = 0; i < n / 2; i++) {
                v[i][i] = i + 1;
                v[0][i + 1] = i + 1;
            }
            for (int i = 0; i < (n - n / 2) / 2 - 1; i++) {
                v[2 * i + n / 2][2 * i + n / 2] = i + n / 2 + 1;
                v[-i + n / 2 - 1 - (n % 2 == 0)][2 * i + n / 2 + 1] = i + n / 2 + 1;
            }
            v[n - 1 - 2][n - 1 - 1] = n / 2 + (n - n / 2) / 2;
            v[1][n - 1] = n / 2 + (n - n / 2) / 2;
            for (int i = n / 2 + (n - n / 2) / 2; i < n - 1; i++) {
                v[0][n - 1 - 1 - (n - i - 2) * 2] = i + 1;
                v[0][n - 1 - 1 - (n - i - 2) * 2 - 1] = i + 1;
            }
            v[0][n - 1] = n - 1;
            for (int i = 0; i < n; i++) {
                v[n - 1][i] = n;
            }
        }else {
            for (int i = 0; i < n / 2; i++) {
                v[i][i] = i + 1;
                v[0][i + 1] = i + 1;
            }
            for (int i = 0; i < (n - n / 2) / 2 - 1; i++) {
                v[2 * i + n / 2][2 * i + n / 2] = i + n / 2 + 1;
                v[-i + n / 2 - 1 - (n % 2 == 0)][2 * i + n / 2 + 1] = i + n / 2 + 1;
            }
            v[n - 1 - 2][n - 1 - 1 - 1] = n / 2 + (n - n / 2) / 2;
            v[2][n - 2] = n / 2 + (n - n / 2) / 2;
            v[n - 2][n - 1] = n / 2 + (n - n / 2) / 2;
            for (int i = n / 2 + (n - n / 2) / 2; i < n - 1; i++) {
                v[0][n - 1 - 1 - (n - i - 2) * 2 + 1] = i + 1;
                v[0][n - 1 - 1 - (n - i - 2) * 2 - 1 + 1] = i + 1;
            }
            for (int i = 0; i < n; i++) {
                v[n - 1][i] = n;
            }
        }
        for (int i = 1; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (!v[i][j]) {
                    v[i][j] = v[i - 1][j];
                }
            }
        }
        for (auto& i : v) {
            for (auto& j : i) {
                cout << j << ' ';
            }cout << '\n';
        }
    }
}
