#include <bits/stdc++.h>

using ll = long long;
using ld =  long long;
using namespace std;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &i: a)out << i << ' ';
    return out;
}

struct line{
    ld k, b;
    line(ld k_ = 1, ld b_ = 1){
        k = k_;
        b = b_;
    }
    ld get(ld x){
        return k*x+b;
    }
};
ld cross(line ln1, line ln2){
    if(ln1.b<ln2.b){
        return 0;
    }
    return (ln1.b-ln2.b+ln2.k-ln1.k-1)/(ln2.k-ln1.k);
}
struct CHT{
    vector<ld> dots;
    vector<line> lines;
    ld inf = 0;
    void add(ll k, ll b){
        line ln = line(k, b);
        while(lines.size()&&dots.size()&&ln.get(dots.back())>lines.back().get(dots.back())){
            lines.pop_back();
            dots.pop_back();
        }
        if(dots.empty()){
            dots.push_back(-inf);
        }
        else{
            dots.push_back(cross(lines.back(), ln));
        }
        lines.push_back(ln);
    }
    ll get(ll x){
        ll ind = upper_bound(dots.begin(), dots.end(), x)-dots.begin()-1;
        return lines[ind].get(x);
    }
};
void slave() {
    ld n, m, c;
    cin>>n>>m>>c;
    vector<ld> x(n+1), t(n+1);
    for(int i = 0; i<n; ++i){
        cin>>x[i+1]>>t[i+1];
        t[i+1]*=c;
    }
    x[0]=0;
    t[0]=0;
    x.push_back(m);
    t.push_back(0);
    n++;
    n++;
    CHT ch;
    vector<ll> dp(n);
    dp[0]=0;
    for(int i = 1; i<n; ++i){
        ch.add(2*x[i-1], -(dp[i-1]+t[i-1]+x[i-1]*x[i-1]));
        dp[i]=-ch.get(x[i])+x[i]*x[i];
    }
    long double xx = dp[n-1];
    cout<<xx/c<<"\n";
}

signed main() {
    cout << fixed << setprecision(17);
#ifdef _GLIBCXX_DEBUG
    freopen(".in", "r", stdin);
    freopen(".out", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#endif
    int AnnaSamsonovaGoSex = 1;
    //cin>>AnnaSamsonovaGoSex;
    while (AnnaSamsonovaGoSex--)slave();
}
