import math


def count_dist(x1, y1, x2, y2, x, y):
    A = y1 - y2
    B = - (x1 - x2)
    C = x1*y2 - x2*y1

    d = A**2 + B**2 + C**2

    return abs(A*x + B*y + C) ** 2 / d


x1, y1, x2, y2, x3, y3 = map(int, input().split())
d1 = count_dist(x1, y1, x2, y2, x3, y3)
d2 = count_dist(x2, y2, x3, y3, x1, y1)
d3 = count_dist(x3, y3, x1, y1, x2, y2)

if min(d1, d2, d3) == d1:
    print(x1, y1, x2, y2)
elif min(d1, d2, d3) == d2:
    print(x2, y2, x3, y3)
else:
    print(x3, y3, x1, y1)
