#include <bits/stdc++.h>
using namespace std;
using ll = long long;
typedef long double ld;

struct line {
    ld k, b;
    line(ld _k = 0, ld _b = 0) : k(_k), b(_b) {}
    ld operator() (ld x) {
        return k * x + b;
    }
};

const int maxn = 3e6;
ld sortpos[maxn];
int pos[maxn];
line t[maxn];

void insert(int v, int l, int r, line l1) {
    if (l + 1 == r) {
        if (l1(sortpos[l]) < t[v](sortpos[l])) {
            t[l] = l1;
        }
        return;
    }
    int mid = (l + r) / 2;
    bool mdif = (l1(sortpos[mid]) < t[v](sortpos[mid]));
    bool ldif = (l1(sortpos[mid]) < t[v](sortpos[mid]));
    if (mdif ^ ldif) {
        insert(v * 2, l, mid, l1);
    } else {
        insert(v * 2 + 1, mid, r, l1);
    }
    if (mdif) {
        t[v] = l1;
    }
}

ld getbans(int v, int l, int r, int ps) {
    if (l + 1 == r) {
        return t[v](sortpos[ps]);
    }
    int mid = (l + r) / 2;
    if (ps < mid) {
        return min(t[v](sortpos[ps]), getbans(v * 2, l, mid, ps));
    }
    return min(t[v](sortpos[ps]), getbans(v * 2 + 1, mid, r, ps));
}

ld dp[maxn];
ld tim[maxn];

int main() {
    cout << fixed << setprecision(30);
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    ld c;
    cin >> n >> m >> c;
    for (int i = 0; i < n; i++) {
        cin >> pos[i] >> tim[i];
        sortpos[i] = pos[i];
    }
    pos[n] = m;
    sortpos[n] = m;
    n++;
    sort(sortpos, sortpos + n);
    dp[0] = 0;
    for (int i = 0; i < n; i++) {
        dp[i] = getbans(1, 0, n, i) + sortpos[i] * sortpos[i] / c + tim[i];
        line nw = line((ld) -2.0l * sortpos[i] / c, sortpos[i] * sortpos[i] / c + dp[i]);
        insert(1, 0, n, nw);
    }
    cout << dp[n - 1] << '\n';
}