#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long long ull;
typedef long double ldl;

bool comp(pair<int, int> &a, pair<int, int> &b){
    if (a.first + a.second < b.first + b.second) return true;
    if (a.first + a.second > b.first + b.second) return false;
    if (a.first < b.first) return true;
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

//    cout << setprecision(20);

    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) cin >> a[i].first;
    for (int i = 0; i < n; i++) cin >> a[i].second;

    for (int i = 0; i < n; i++){
        if (a[i].first > a[i].second) swap(a[i].first, a[i].second);
    }
    sort(a.begin(), a.end(), comp);

    bool ans = true;
    for (int i = 1; i < n; i++){
        if (a[i - 1].first > a[i].first or a[i - 1].second > a[i].second) ans = false;
    }

    if (!ans) cout << -1;
    else {
        for (auto &[el1, el2]: a) cout << el1 << ' ';
        cout << '\n';
        for (auto &[el1, el2]: a) cout << el2 << ' ';
    }

    return 0;
}
