#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long long ull;
typedef long double ldl;

ll x1, y11, x2, y2, x3, y3, a1, b1, c1;
ll def_val = 1e11;

ldl f(ll a, ll b, ll c){
    ldl d1 = abs((ldl)a * x1 + b * y11 + c) / sqrt(a * a + b * b);
    ldl d2 = abs((ldl)a * x2 + b * y2 + c) / sqrt(a * a + b * b);
    ldl d3 = abs((ldl)a * x1 + b * y3 + c) / sqrt(a * a + b * b);
    return d1 + d2 + d3;
}

ldl g(ll a, ll b){
    ll l = -def_val, r = def_val, m1, m2;

    while (r - l > 3){
        m1 = (2 * l + r) / 3;
        m2 = (l + 2 * r) / 3;

        if (f(a, b, m1) > f(a, b, m2)) l = m1;
        else r = m2;
    }

    ll ans = l;
    ldl ansf = f(a, b, ans);
    for (ll i = l + 1; i <= r; i++){
        ldl i_f = f(a, b, i);
        if (ansf > i_f) ans = i, ansf = i_f;
    }
    c1 = ans;
    return ansf;
}

ldl h(ll a){
    ll l = -def_val, r = def_val, m1, m2;

    while (r - l > 3){
        m1 = (2 * l + r) / 3;
        m2 = (l + 2 * r) / 3;

        if (g(a, m1) > g(a, m2)) l = m1;
        else r = m2;
    }

    ll ans = l;
    ldl ansf = g(a, ans);
    for (ll i = l + 1; i <= r; i++){
        ldl i_f = g(a, i);
        if (ansf > i_f) ans = i, ansf = i_f;
    }
    b1 = ans;
    return ansf;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cout << setprecision(20);

    cin >> x1 >> y11 >> x2 >> y2 >> x3 >> y3;

    ll l = -1e11, r = 1e11, m1, m2;
    while (r - l > 3){
        m1 = (2 * l + r) / 3;
        m2 = (l + 2 * r) / 3;

        if (h(m1) > h(m2)) l = m1;
        else r = m2;
    }

    ll ans = l;
    ldl ansf = h(ans);
    for (ll i = l + 1; i <= r; i++){
        ldl i_f = h(i);
        if (ansf > i_f) ans = i, ansf = i_f;
    }
    a1 = ans;

    if (b1 == 0){
        ll x_ans = -c1 / a1;
        cout << x_ans << ' ' << 0 << ' ' << x_ans << ' ' << 1;
    } else {
        ll y_ans = (-c1 - a1) / b1;
        cout << 1 << ' ' << y_ans << ' ';
        ll y_ans1 = (-c1 + a1) / b1;
        cout << -1 << ' ' << y_ans1;
    }

    return 0;
}
