#include <iostream>
#include <vector>
using namespace std;

using ll = long long;
ll gcd(ll a, ll b) {
	if (a < b) swap(a, b);
	while (b > 0) {
		ll m = b;
		b = a % b;
		a = m;
	}
	return a;
}

ll inf = 1e6;

int main() {
	ll a;
	ll n;
	cin >> n >> a;
	ll p = 1;
	for (int i = 0; i < n; i++) {
		p *= 10;
	}
	ll g = gcd(a, p);
	a = a / g;
	p = p / g;
	if (a >= inf || p >= inf) cout << "NO\n";
	else {
		cout << "YES\n";
		cout << a << ' ' << p << '\n';
	}
}