#include <iostream>
#include <vector>
#include <iomanip>
using namespace std;

using ld = long double;

int main() {
	int n;
	ld m, c;
	cin >> n >> m >> c;
	vector<ld> x(n + 2);
	vector<ld> t(n + 2);
	x[0] = 0;
	t[0] = 0;
	x[n + 1] = m;
	t[n + 1] = 0;
	for (int i = 1; i <= n; i++) {
		cin >> x[i];
		cin >> t[i];
	}
	vector<ld> dp(n + 2);
	dp[0] = 0;
	int last = 0;
	for (int i = 1; i <= n + 1; i++) {
		dp[i] = t[i];
		ld addl = dp[last] + (x[i] - x[last]) * (x[i] - x[last]) / c;
		ld addi = dp[i - 1] + (x[i] - x[i - 1]) * (x[i] - x[i - 1]) / c;
		if (addi <= addl) {
			dp[i] += addi;
			last = i - 1;
		} else {
			dp[i] += addl;
		}
	}
	cout << setprecision(8) << fixed;
	cout << dp[n + 1];
}