#include <iostream>
#include <cmath>
#include <vector>
#include <map>

using namespace std;

using ll = long long;
using ld = long double;

int main() {
    ll n, q;
    cin >> n >> q;
    vector<map<ll, ll>> base(1e5);
    vector<ll> edges(1e5, 0);
    vector<ll> get(1e5, 1);
    vector<ll> wa(1e5, 0);
    ll cur = 0;
    while (q--) {
        char type;
        ll v, u, c;
        cin >> type >> v >> u >> c;
        v--;
        u--;
        c--;
        if (type == '+') {
            edges[c]++;
            base[c][v]++;
            base[c][u]++;
            if (base[c][v] == 2) {
                wa[c]++;
            }
            if (base[c][u] == 2) {
                wa[c]++;
            }
            if (get[c]) {
                if (wa[c] == 0) {
                    cur++;
                } else {
                    cur -= edges[c] - 1;
                    get[c] = 0;
                }
            }
        } else {
            edges[c]--;
            base[c][v]--;
            base[c][u]--;
            if (base[c][v] == 1) {
                wa[c]--;
            }
            if (base[c][u] == 1) {
                wa[c]--;
            }
            if (!get[c]) {
                if (wa[c] == 0) {
                    cur += edges[c];
                    get[c] = 1;
                }
            } else {
                cur--;
            }
        }
        cout << cur << '\n';
    }
    return 0;
}
