#include <bits/stdc++.h>

using namespace std;

/*#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,bmi2,fma")*/

#define int long long
#define double long double

vector<int> tek;

void dfs(int v, vector<vector<int>> & g) {
    tek.push_back(v);
    for (auto u : g[v]) {
        dfs(u, g);
    }
}

pair<double, double> peres(double x1, double y1, double r1, double x2, double y2, double r2) {
    x2 -= x1;
    y2 -= y1;
    double a = r1 * r1 - r2 * r2 + x2 * x2 + y2 * y2;
    double b = 4 * (x2 * x2 + y2 * y2);
    double c = 4 * a * y2;
    double d = a * a - 4 * x2 * x2 * r1 * r1;
    double sqrt_d = sqrt(c * c - 4 * b * d);
    double y = (c - sqrt_d) / (2 * b);
    double x = (a - 2 * y * y2) / (2 * x2);
    return {x + x1, y + y1};
}

void solve() {
    double x1, y1, x2, y2;
    cin >> x1 >> y1 >> x2 >> y2;
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> pred(n, -1);
    set<pair<int, int>> s;
    for (int i = 0; i < n; i++) {
        s.insert({a[i], i});
    }
    int sum = 0;
    for (int i = 0; i < n; i++) {
        sum += a[i];
    }
    double d = sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
    if (d > (double)(sum)) {
        cout << "Impossible\n";
        return;
    }
    int mx = (*(--s.end())).first;
    if (2 * mx > d + sum) {
        cout << "Impossible\n";
        return;
    }
    for (int i = 0; i < n; i++) {
        if (s.size() <= 3) {
            break;
        }
        int s1, i1, s2, i2;
        s1 = (*s.begin()).first;
        i1 = (*s.begin()).second;
        s2 = (*(++s.begin())).first;
        i2 = (*(++s.begin())).second;
        s.erase(s.find({s1, i1}));
        s.erase(s.find({s2, i2}));
        pred[i1] = i2;
        s2 += s1;
        s.insert({s2, i2});
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < n; i++) {
        if (pred[i] != -1) {
            g[pred[i]].push_back(i);
        }
    }
    vector<int> sss, iii;
    for (auto u : s) {
        sss.push_back(u.first);
        iii.push_back(u.second);
    }
    int ost = (int)sss.size();
    map<int, vector<int>> ggg;
    for (int i = 0; i < ost; i++) {
        dfs(iii[i], g);
        ggg[iii[i]] = tek;
        tek.clear();
    }
    /*for (auto u : ggg) {
        cout << u.first << "\n";
        for (auto uu : u.second) {
            cout << uu << " ";
        }
        cout << "\n";
    }*/
    vector<pair<int, int>> f(ost);
    for (int i = 0; i < ost; i++) {
        f[i] = {sss[i], iii[i]};
    }
    vector<double> napr(n);
    sort(f.begin(), f.end());
    if (f[0].first + f[1].first <= d + f[2].first) {
        f[0].first += f[1].first;
        for (auto u : ggg[f[1].second]) {
            ggg[f[0].second].push_back(u);
        }
        double r1, r2;
        r1 = f[0].first;
        r2 = f[2].first;
        auto [x0, y0] = peres(x1, y1, r1, x2, y2, r2);
        for (auto u : ggg[f[0].second]) {
            napr[u] = atan2(y0 - y1, x0 - x1);
        }
        for (auto u : ggg[f[2].second]) {
            napr[u] = atan2(y2 - y0, x2 - x0);
        }
    } else {
        double x3, y3;
        x3 = x1 - (x2 - x1) / d * f[0].first;
        y3 = y1 - (y2 - y1) / d * f[0].first;
        for (auto u : ggg[f[0].second]) {
            napr[u] = atan2(y1 - y2, x1 - x2);
        }
        double r1 = f[1].first;
        double r2 = f[2].first;
        auto [x0, y0] = peres(x3, y3, r1, x2, y2, r2);
        for (auto u : ggg[f[1].second]) {
            napr[u] = atan2(y0 - y1, x0 - x1);
        }
        for (auto u : ggg[f[2].second]) {
            napr[u] = atan2(y2 - y0, x2 - x0);
        }
    }
    double x_tek, y_tek;
    x_tek = x1;
    y_tek = y1;
    cout << "Possible\n";
    cout.precision(30);
    for (int i = 0; i < n; i++) {
        x_tek += cos(napr[i]) * a[i];
        y_tek += sin(napr[i]) * a[i];
        cout << x_tek << " " << y_tek << "\n";
    }
}

signed main()
{
#ifdef Lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int _ = 1;
    //cin >> _;
    while (_--)
    {
        solve();
    }
}
