#include <bits/stdc++.h>

using namespace std;

/*#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,bmi2,fma")*/

//#define int long long
//#define double long double

long long inf = (long long) (1ll * 1000 * 1000 * 1000 * 1000 * 1000 * 1000 + 10);

pair<double, double> diap[250010];
pair<double, double> cht[250010];
int sz;

double get(double x) {
    int l = 0;
    int r = sz;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (diap[m].first <= x) {
            l = m;
        } else {
            r = m;
        }
    }
    return cht[l].first * x + cht[l].second;
}

void update(double k, double b) {
    while (true) {
        if (sz == 0) {
            diap[sz] = {(double)(0), (double)inf};
            cht[sz] = {k, b};
            sz++;
            break;
        }
        double k1, b1;
        k1 = cht[sz - 1].first;
        b1 = cht[sz - 1].second;
        double x_per = max((double)(0), min((double)((b1 - b) / (k - k1)), (double)inf));
        if ((x_per > diap[sz - 1].first) && (x_per <= (double)inf)) {
            diap[sz - 1].second = x_per;
            diap[sz] = {x_per, (double)inf};
            cht[sz] = {k, b};
            sz++;
            break;
        } else {
            sz--;
        }
    }
}



void solve()
{
    auto start = clock();
    int n, m;
    double c;
    cin >> n >> m >> c;
    vector<double> x(n + 2);
    vector<double> t(n + 2);
    for (int i = 0; i < n; i++) {
        cin >> x[i + 1] >> t[i + 1];
    }
    x[0] = 0;
    x[n + 1] = m;
    t[0] = 0;
    t[n + 1] = 0;
    diap[0] = {(double)(0), (double)inf};
    cht[0] = {0, 0};
    sz = 1;
    vector<double> dp(n + 2);
    dp[0] = 0;
    for (int i = 1; i <= n + 1; i++) {
        dp[i] = get(x[i]) + x[i] * x[i] / c + t[i];
        update(-2 * x[i] / c, (dp[i] + x[i] * x[i] / c));
        if ((long double)(clock() - start) / (long double)(CLOCKS_PER_SEC) >= 0.9) {
            cout << 1/0;
            return;
        }
    }
    cout.precision(30);
    cout << dp[n + 1] << "\n";
}

signed main()
{
#ifdef Lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int _ = 1;
    //cin >> _;
    while (_--)
    {
        solve();
    }
}
